#!/usr/bin/perl



# Takes a FASTQ file of S2 library data and splits according to two barcodes



use strict ;

use warnings ;



# Get ARGS

my $usage = "Usage: $0 <FASTQ file> <root name of output file> \n" ;

my $FASTQ_file = shift or die $usage ;

my $output_file = shift or die $usage ;



# test ARGS

die "Could not read FASTQ file\\n" unless -r $FASTQ_file ;

mkdir 'output' ;

  

# open files

open (OUTPUT_FILE0A, ">output/0A_$output_file" ) || die "Could not create output file 0A\n" ;

open (OUTPUT_FILE0B, ">output/0B_$output_file" ) || die "Could not create output file 0B\n" ;

open (OUTPUT_FILE0C, ">output/0C_$output_file" ) || die "Could not create output file 0C\n" ;

open (OUTPUT_FILE0D, ">output/0D_$output_file" ) || die "Could not create output file 0D\n" ;

open (OUTPUT_FILE1A, ">output/1A_$output_file" ) || die "Could not create output file 1A\n" ;

open (OUTPUT_FILE1B, ">output/1B_$output_file" ) || die "Could not create output file 1B\n" ;

open (OUTPUT_FILE1C, ">output/1C_$output_file" ) || die "Could not create output file 1C\n" ;

open (OUTPUT_FILE1D, ">output/1D_$output_file" ) || die "Could not create output file 1D\n" ;

open (OUTPUT_FILE2A, ">output/2A_$output_file" ) || die "Could not create output file 2A\n" ;

open (OUTPUT_FILE2B, ">output/2B_$output_file" ) || die "Could not create output file 2B\n" ;

open (OUTPUT_FILE2C, ">output/2C_$output_file" ) || die "Could not create output file 2C\n" ;

open (OUTPUT_FILE2D, ">output/2D_$output_file" ) || die "Could not create output file 2D\n" ;

open (OUTPUT_FILE3A, ">output/3A_$output_file" ) || die "Could not create output file 3A\n" ;

open (OUTPUT_FILE3B, ">output/3B_$output_file" ) || die "Could not create output file 3B\n" ;

open (OUTPUT_FILE3C, ">output/3C_$output_file" ) || die "Could not create output file 3C\n" ;

open (OUTPUT_FILE3D, ">output/3D_$output_file" ) || die "Could not create output file 3D\n" ;

open (OUTPUT_FILE4A, ">output/4A_$output_file" ) || die "Could not create output file 4A\n" ;

open (OUTPUT_FILE4B, ">output/4B_$output_file" ) || die "Could not create output file 4B\n" ;

open (OUTPUT_FILE4C, ">output/4C_$output_file" ) || die "Could not create output file 4C\n" ;

open (OUTPUT_FILE4D, ">output/4D_$output_file" ) || die "Could not create output file 4D\n" ;

open (OUTPUT_FILE5A, ">output/5A_$output_file" ) || die "Could not create output file 5A\n" ;

open (OUTPUT_FILE5B, ">output/5B_$output_file" ) || die "Could not create output file 5B\n" ;

open (OUTPUT_FILE5C, ">output/5C_$output_file" ) || die "Could not create output file 5C\n" ;

open (OUTPUT_FILE5D, ">output/5D_$output_file" ) || die "Could not create output file 5D\n" ;

open (OUTPUT_FILE6A, ">output/6A_$output_file" ) || die "Could not create output file 6A\n" ;

open (OUTPUT_FILE6B, ">output/6B_$output_file" ) || die "Could not create output file 6B\n" ;

open (OUTPUT_FILE6C, ">output/6C_$output_file" ) || die "Could not create output file 6C\n" ;

open (OUTPUT_FILE6D, ">output/6D_$output_file" ) || die "Could not create output file 6D\n" ;

open (OUTPUT_FILE7A, ">output/7A_$output_file" ) || die "Could not create output file 7A\n" ;

open (OUTPUT_FILE7B, ">output/7B_$output_file" ) || die "Could not create output file 7B\n" ;

open (OUTPUT_FILE7C, ">output/7C_$output_file" ) || die "Could not create output file 7C\n" ;

open (OUTPUT_FILE7D, ">output/7D_$output_file" ) || die "Could not create output file 7D\n" ;

open (OUTPUT_FILE8A, ">output/8A_$output_file" ) || die "Could not create output file 8A\n" ;

open (OUTPUT_FILE8B, ">output/8B_$output_file" ) || die "Could not create output file 8B\n" ;

open (OUTPUT_FILE8C, ">output/8C_$output_file" ) || die "Could not create output file 8C\n" ;

open (OUTPUT_FILE8D, ">output/8D_$output_file" ) || die "Could not create output file 8D\n" ;

open (OUTPUT_FILE9A, ">output/9A_$output_file" ) || die "Could not create output file 9A\n" ;

open (OUTPUT_FILE9B, ">output/9B_$output_file" ) || die "Could not create output file 9B\n" ;

open (OUTPUT_FILE9C, ">output/9C_$output_file" ) || die "Could not create output file 9C\n" ;

open (OUTPUT_FILE9D, ">output/9D_$output_file" ) || die "Could not create output file 9D\n" ;

open (OUTPUT_FILE_UM, ">output/unmatched_$output_file" ) || die "Could not create output file for unmatched reads\n" ;

open (FASTQ_FILE, "<$FASTQ_file") || die "Could not open FASTQ file\n" ;



# Initialise variables

my $name = '0' ;

my $sequence = '0' ;

my $score = '0' ;

my $FASTQline = '0' ;

my $count = 0 ;



# Collect name and sequence from FASTQ file

while ( my $FASTQline = <FASTQ_FILE>)

{

  # Collect name and sequence

  chomp $FASTQline ; 

  if ($FASTQline =~ /^@(\S+)/  )

    {

      $name = $1 ;

      $sequence = <FASTQ_FILE> ;

      chomp $sequence ;

    

    # Collect score

    $score = <FASTQ_FILE> ;

    if ($score =~ /^\+/)

      {

	$score = <FASTQ_FILE> ;

	chomp $score ;

      }

    }

  

# If barcode #0 output to file #0

  if ($sequence =~ /^TAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode 

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE0A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

	# print "$name\t$crop_sequence\t$crop_score\n" ;

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE0B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE0C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE0D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }

    

# If barcode #1 output to file #1

  if ($sequence =~ /^CTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE1A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE1B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE1C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE1D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #2 output to file #2

  if ($sequence =~ /^AGTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE2A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE2B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE2C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE2D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #3 output to file #3

  if ($sequence =~ /^TACTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE3A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE3B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE3C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE3D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #4 output to file #4

  if ($sequence =~ /^CTGCTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE4A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE4B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE4C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE4D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #5 output to file #5

  if ($sequence =~ /^GCAGCTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE5A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE5B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE5C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE5D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #6 output to file #6

  if ($sequence =~ /^TCCAAGTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE6A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE6B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE6C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE6D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #7 output to file #7

  if ($sequence =~ /^ATGCTAGTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE7A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE7B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE7C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE7D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #8 output to file #8

  if ($sequence =~ /^GATGCTACTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE8A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE8B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE8C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE8D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If barcode #9 output to file #9

  if ($sequence =~ /^CGATGCCACTAGGTATGTTTTCCTCAATACTTCG/g)

    {

    

    # Crop up to end of 5' barcode and other end

    my $crop_sequence = substr $sequence, pos($sequence), 19;

    my $crop_score = substr $score, pos($sequence), 19;

    

    # Look for second barcode

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACCGTGAT/g)

      {

	# Print to output file A

	print ( OUTPUT_FILE9A "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACACATCG/g)

      {

	# Print to output file B

	print ( OUTPUT_FILE9B "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACGCCTAA/g)

      {

	# Print to output file C

	print ( OUTPUT_FILE9C "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    if ($sequence =~ /ACACGTCTGAACTCCAGTCACTGGTCA/g)

      {

	# Print to output file D

	print ( OUTPUT_FILE9D "\@$name\n$crop_sequence\n\+\n$crop_score\n" );

      }

    }



# If no matches increase unmatched read counter, and output reads to not matched file

if ($sequence !~ /^TAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^CTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^AGTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^TACTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^CTGCTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^GCAGCTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^TCCAAGTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^ATGCTAGTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^GATGCTACTAGGTATGTTTTCCTCAATACTTCG/g and

    $sequence !~ /^CGATGCCACTAGGTATGTTTTCCTCAATACTTCG/g )

    {

      $count ++ ;

      print ( OUTPUT_FILE_UM "\@$name\n$sequence\n\+\n$score\n" );

    }



}



print "Unmatched reads = $count \n" ;

close OUTPUT_FILE0A;

close OUTPUT_FILE0B;

close OUTPUT_FILE0C;

close OUTPUT_FILE0D;

close OUTPUT_FILE1A;

close OUTPUT_FILE1B;

close OUTPUT_FILE1C;

close OUTPUT_FILE1D;

close OUTPUT_FILE2A;

close OUTPUT_FILE2B;

close OUTPUT_FILE2C;

close OUTPUT_FILE2D;

close OUTPUT_FILE3A;

close OUTPUT_FILE3B;

close OUTPUT_FILE3C;

close OUTPUT_FILE3D;

close OUTPUT_FILE4A;

close OUTPUT_FILE4B;

close OUTPUT_FILE4C;

close OUTPUT_FILE4D;

close OUTPUT_FILE5A;

close OUTPUT_FILE5B;

close OUTPUT_FILE5C;

close OUTPUT_FILE5D;

close OUTPUT_FILE6A;

close OUTPUT_FILE6B;

close OUTPUT_FILE6C;

close OUTPUT_FILE6D;

close OUTPUT_FILE7A;

close OUTPUT_FILE7B;

close OUTPUT_FILE7C;

close OUTPUT_FILE7D;

close OUTPUT_FILE8A;

close OUTPUT_FILE8B;

close OUTPUT_FILE8C;

close OUTPUT_FILE8D;

close OUTPUT_FILE9A;

close OUTPUT_FILE9B;

close OUTPUT_FILE9C;

close OUTPUT_FILE9D;

close OUTPUT_FILE_UM;

close FASTQ_FILE;

