#!/usr/bin/perl



# Takes a list of features and searches for each of these in a FASTQ file to count the number of times it appears

# Can accept multiple FASTQ files to search in

# Now takes directory and uses all FASTQ files in directory



use strict ;

use warnings ;



# Get ARGS

my $usage = "Usage: $0 <list of names to search for> <Directory containing split FASTQ files (.fastq)> <name of output file> \n" ;

my $name_file = shift or die $usage ;

my $dir = shift or die $usage ;

my $output_file = shift or die $usage ;



# test ARGS

die "Could not read name file\\n" unless -r $name_file ;



# open files

open (OUTPUT_FILE, ">$output_file" ) || die "Could not create output file\n" ;

open (NAME_FILE, "<$name_file") || die "Could not open name file\n" ;

opendir (DIR, $dir) or die "Can't open $dir: $!";



my $file = '0' ;

my $name = '0' ;

my $sequence = '0' ;

my $nameline = '0' ;

my $count = 0 ;



# Collect sequence name from name file

while ( my $nameline = <NAME_FILE>)

{

  chomp $nameline ; 

  if ($nameline =~ /^(\S+,\S+,\d+),(\S+)\t[+-]\t\S+\t\d+\t(\S+)\t\S+\t\d+/  )

    {

    $name = "$1,$2" ;

    my $PAM = substr $2, 0, 2 ;

    $sequence = $3;

    # print "$name\t$1\t$2\t$sequence\n";

    # print "$PAM\n";

    

    # If sequence is on reverse strand, reverse complement sequence

    if ($PAM =~ /CC/g)

      {  

      $sequence =~ tr/ATGCatgcNn/TACGtacgNn/ ;

      $sequence = reverse $sequence ;

      }

    

    # Get 19 nt before PAM sequence

    $sequence = substr $sequence, 1, 19;

    

    # Print names and sequences

    print ( OUTPUT_FILE "$name\t$sequence\t" );

    print "$name\t$sequence\t" ;



	# Read in next .fastq file in directory

        opendir (DIR, $dir) or die "Can't open $dir: $!";

	while ($file = readdir (DIR)) 

        {

		until ($file =~ /\S+.fastq/)

		{

		    $file = readdir (DIR) ;

		}

		print "$file\t" ;

		

		# open FASTQ file

		open (FASTQFILE1, "<$dir/$file") || die "Could not open FASTQ file $dir/$file\n" ;

	    

		# Collect information from FASTQ file

		while ( my $FASTQline = <FASTQFILE1>)

		{

		  if ($FASTQline =~ /^\@/)

		  {

		  #Read in sequence line

		  $FASTQline = <FASTQFILE1> ;

		  chomp $FASTQline ;

		  #print "$FASTQline,$sequence\n" ;

		  if ($FASTQline =~ /$sequence/g )

			{

			$count ++ ;

			}

		  }

		}

	    

	    # Print number in FASTQ file to output file

	    print ( OUTPUT_FILE "$count\t" );

	    print "$count\t" ;

	    

	    # Reset counter

	    $count = 0 ;

	    close FASTQFILE1;

	}

	print ( OUTPUT_FILE "\n" );

	print "\n" ;

	closedir (DIR) ;

    }

  else {print "not good line\n"}

}

 

close OUTPUT_FILE;

close NAME_FILE;

close FASTQFILE1;

